--[[--------------------------------------------------
--Juked by Robrman, Inspired by Kollektiv's InterruptBar
--Version 1.2.9
CHANGELOG:
--Added Readiness resetting Scatter Shot and Deterrence, I probably missed some..its 5 am nobody on to help me test fully, sorry if its incomplete post and i'll fix it
--Cleaned up some of the code, fixed some errors with repositioning
--Added individual locking, hiding and smart modes, still possibly buggy
--Fixed moving, probably still some work to be done there
--Cleaned up the help menu a bit, feedback is appreciated
--Added scaling for main bar and prio bar individually
--Fixed possible problem with Gnaw if used by a transformed ghoul (Thanks Damnationx)
--Fixed Death Coil cooldown to account for Warlock 4 piece bonus -30 seconds (Thanks Damnationx)
--Fixed cooldown timer restarting (if same CD is popped, restart timer. Thanks Damnationx)
--Added Inner Focus   {spellID=89485, time=45, prio=false},--Inner Focus     (Thanks Sazalolz, cant believe i missed it)
--Added /juked prioonly   this will ONLY display cooldowns for spells marked with prio=true
--Added noCD option to disable the numeric cooldown from Juked 
--Fixed some cooldown durations(Thanks Sazalolz for pointing it out)
--Externalized the spell table(Thanks Sazalolz for the suggestion)
--Added test for all modes
--Added a fix for some versions of omniCC
--Fixed Rebuke spellID
--Addon can now be accessed from /juked   /jd   and   /ib(kept this cause i kept typing it by accident)
--Added the option to grow the bars upward from the anchor /juked
TODO:
--I should probably rewrite the help menu, very cluttered right now
----------------------------------------------------]]

JukedDB = JukedDB or { scale = 1,scale2=1 , hidden = false,hidden2=false, smart=false, smartPrio=false,prio = false, cols=6, colsPrio=6, arenaOnly=false, bgOnly=false, lock = false,growUp=-1,growLeft=-1, noCD=false,prioOnly=false,}
local abilities = {}
local order
local arena=false
local bg=false
local band = bit.band
local spell_table=spell_table
--[[
TO ADD:
-- Smoke bomb once it can be tracked
--]]
-----------------------------------------------------
-----------------------------------------------------
if spell_table==nil then ChatFrame1:AddMessage("NOT LOADED",0,1,0) end
for k,spell in ipairs(spell_table) do
	local name,_,spellicon = GetSpellInfo(spell.spellID)	
	abilities[spell.spellID] = { icon = spellicon, duration = spell.time }
end

local frame
local bar
local bar2

local x = -60
local x2 = -60
local y2 = 0
local count2 = 0
local count=0
local y=0
local totalIcons=0
local GetTime = GetTime
local ipairs = ipairs
local pairs = pairs
local select = select
local floor = floor
local band = bit.band
local GetSpellInfo = GetSpellInfo


local GROUP_UNITS = bit.bor(0x00000010, 0x00000400)

local activetimers = {}

local size = 0
local function getsize()
	size = 0
	for k in pairs(activetimers) do
		size = size + 1
	end
end

local function isInBG()
	local a,type = IsInInstance()
	if (type == "pvp") then
		return true
	end
	return false
end

local function isInArena()
	local _,type = IsInInstance()
	if (type == "arena") then
		return true
	end
	return false
	
end
local function isPrio(ability)
	for _,v in ipairs(spell_table) do
		if v.spellID==ability then--find ability in table
			return v.prio--return prio status for ability
		end
	end
	return false
end

local function getTotalPrio()
	local ret=0
	if JukedDB.prio then
		for _,v in ipairs(spell_table) do
			if v.prio then
				ret=ret+1
			end
		end
	end
	return ret
end

local function getTotalMain()
	local ret=0
	if JukedDB.prio then
		for _,v in ipairs(spell_table) do
			if not v.prio then
				ret=ret+1
			end
		end
		return ret
	end
	return #(spell_table)
end

local function Juked_AddIcons()
	for _,ability in ipairs(spell_table) do--for all spells in spell table
		local btn = CreateFrame("Frame",nil,bar)
		btn:SetWidth(30)--create the frame and set the dimensions
		btn:SetHeight(30)
		
		if JukedDB.prio and isPrio(ability.spellID) then
			btn:SetPoint("TOPRIGHT",bar2,"TOP",x2,y2)
		else
			--btn:SetPoint("TOPRIGHT",bar,"TOP",x,y)
			btn:SetPoint("CENTER",bar,"CENTER",x,y)
		end
			
		btn:SetFrameStrata("LOW")
		local cd = CreateFrame("Cooldown",nil,btn)
		cd.noomnicc = not JukedDB.noCD
		cd.noOCC = not JukedDB.noCD
		cd.noCooldownCount = not JukedDB.noCD
		
		cd:SetAllPoints(true)
		cd:SetFrameStrata("LOW")
		cd:Hide()
		
		local texture = btn:CreateTexture(nil,"BACKGROUND")
		texture:SetAllPoints(true)
		texture:SetTexture(abilities[ability.spellID].icon)
		texture:SetTexCoord(0.07,0.9,0.07,0.90)
	
		local text = cd:CreateFontString(nil,"ARTWORK")
		text:SetFont(STANDARD_TEXT_FONT,18,"OUTLINE")
		text:SetTextColor(1,1,0,1)
		text:SetPoint("LEFT",btn,"LEFT",1,0)
		
		btn.texture = texture
		btn.text = text
		btn.duration = abilities[ability.spellID].duration
		btn.cd = cd
		
		if JukedDB.prio and isPrio(ability.spellID) then
			bar2[ability.spellID] = btn
			if (JukedDB.prioOnly and not isPrio(ability.spellID)) then bar2[ability.spellID]:Hide() end
			x2 = x2 + 30 * JukedDB.growLeft
			count2 = count2 + 1
			totalIcons = totalIcons + 1
			if count2 >= JukedDB.colsPrio and JukedDB.colsPrio > 0 then
				y2 = y2 - 30 * JukedDB.growUp
				x2 =-60
				count2=0
			end
		else
			bar[ability.spellID] = btn
			if (JukedDB.prioOnly and not isPrio(ability.spellID)) then bar[ability.spellID]:Hide() end
			x = x + 30 * JukedDB.growLeft
			count = count + 1
			totalIcons = totalIcons + 1
			if count >= JukedDB.cols and JukedDB.cols > 0 then
				y = y - 30 * JukedDB.growUp
				x=-60
				count=0
			end
		end
	end
	x = -60
	count=0
	y=0
	active=0
	x2 = -60
	count2=0
	y2=0
end

local function Juked_AddIcon(ability)
if (JukedDB.prioOnly and not isPrio(ability)) then return end
	if JukedDB.prio and isPrio(ability) then
		if not bar2[ability]:IsVisible() then
			--[[if not (JukedDB.growUp==-1 or JukedDB.growLeft==-1) then
				bar2[ability]:SetPoint("TOPRIGHT",bar2,"TOP",x2,y2)
			elseif (JukedDB.growUp==-1) then
			bar2[ability]:SetPoint("TOPRIGHT",bar2,"TOP",x2,y2)
				--bar2[ability]:SetPoint("BOTTOMRIGHT",bar2,"BOTTOM",x2,y2)
			else
				bar2[ability]:SetPoint("TOPRIGHT",bar2,"TOP",x2,y2)
			end
			bar2[ability]:Show()
			x2 = x2 + 30 * JukedDB.growLeft
			count2 = count2 + 1
			if count2 >= JukedDB.colsPrio and JukedDB.colsPrio > 0 then
				y2 = y2 - 30 * JukedDB.growUp
				x2=-60
				count2=0
			end]]
			if not (JukedDB.growUp==-1) and not (JukedDB.growLeft==-1) then
				if (JukedDB.colsPrio == 0) then
					bar2[ability]:SetPoint("CENTER",bar2,"CENTER",x2-((getTotalPrio()/2)*30)+60,y2)
				elseif (JukedDB.colsPrio>9) then
					bar2[ability]:SetPoint("TOPRIGHT",bar2,"TOP",x2-((JukedDB.colsPrio-9)*30)-15,y2)
				elseif (JukedDB.colsPrio>6) then
					bar2[ability]:SetPoint("TOPRIGHT",bar2,"TOP",x2-30,y2)
				elseif (JukedDB.colsPrio==5 or JukedDB.colsPrio==6)then
					bar2[ability]:SetPoint("TOPRIGHT",bar2,"TOP",x2,y2)
				else
					bar2[ability]:SetPoint("TOPRIGHT",bar2,"TOP",x2+((abs(5-JukedDB.colsPrio))*30)-15,y2)
				end
			elseif (JukedDB.growUp==-1) and (JukedDB.growLeft==-1) then
				if (JukedDB.colsPrio > 4)then
					bar2[ability]:SetPoint("TOPRIGHT",bar2,"TOP",x2+((JukedDB.colsPrio-2)*30),y2)
				else
					bar2[ability]:SetPoint("TOPRIGHT",bar2,"TOP",x2+((JukedDB.colsPrio)*30)+30,y2)
				end
			elseif (JukedDB.growUp==-1) then
				if (JukedDB.colsPrio>6) then
					bar[ability]:SetPoint("TOPRIGHT",bar2,"TOP",x2-((JukedDB.colsPrio-6)*30)+30,y2)
				elseif (JukedDB.colsPrio==6) then 
					bar2[ability]:SetPoint("TOPRIGHT",bar2,"TOP",x2,y2)
				else
					bar2[ability]:SetPoint("TOPRIGHT",bar2,"TOP",x2+30,y2)
				end
			elseif (JukedDB.growLeft==-1) then
				if (JukedDB.colsPrio == 0)then
					bar2[ability]:SetPoint("CENTER",bar2,"CENTER",x2+((getTotalPrio()/2)*30)+60,y2)
				elseif (JukedDB.colsPrio>8) then
					if (JukedDB.colsPrio%2==0) then
						bar2[ability]:SetPoint("TOPRIGHT",bar2,"TOP",x2+((JukedDB.colsPrio-2)*30)-30,y2)
					else
						bar2[ability]:SetPoint("TOPRIGHT",bar2,"TOP",x2+((JukedDB.colsPrio-2)*30)-15-((JukedDB.colsPrio-10)*30),y2)
					end
				elseif (JukedDB.colsPrio>4) then
					bar2[ability]:SetPoint("TOPRIGHT",bar2,"TOP",x2+((JukedDB.colsPrio-1)*30),y2)
				else
					bar2[ability]:SetPoint("TOPRIGHT",bar2,"TOP",x2+((JukedDB.colsPrio)*30)+(30*(JukedDB.colsPrio%2))-15*(JukedDB.colsPrio%2),y2)
				end
			end
		
			bar2[ability]:Show()
			x2 = x2 + 30 * JukedDB.growLeft
			count2 = count2 + 1
			if count2 >= JukedDB.colsPrio and JukedDB.colsPrio > 0 then
				y2 = y2 - 30 * JukedDB.growUp
				x2=-60
				count2=0
			end
		end
	else
		if not bar[ability]:IsVisible() then
			if not (JukedDB.growUp==-1) and not (JukedDB.growLeft==-1) then
				if (JukedDB.cols == 0)then
					bar[ability]:SetPoint("CENTER",bar,"CENTER",x-((getTotalMain()/2)*30)+60,y)
				elseif (JukedDB.cols>9) then
					bar[ability]:SetPoint("TOPRIGHT",bar,"TOP",x-((JukedDB.cols-9)*30)-15,y)
				elseif (JukedDB.cols>6) then
					bar[ability]:SetPoint("TOPRIGHT",bar,"TOP",x-30,y)
				elseif (JukedDB.cols==5 or JukedDB.cols==6)then
					bar[ability]:SetPoint("TOPRIGHT",bar,"TOP",x,y)
				else
					bar[ability]:SetPoint("TOPRIGHT",bar,"TOP",x+((abs(5-JukedDB.cols))*30)-15,y)
				end
			elseif (JukedDB.growUp==-1) and (JukedDB.growLeft==-1) then
				if (JukedDB.cols > 4)then
					bar[ability]:SetPoint("TOPRIGHT",bar,"TOP",x+((JukedDB.cols-2)*30),y)
				else
					bar[ability]:SetPoint("TOPRIGHT",bar,"TOP",x+((JukedDB.cols)*30)+30,y)
				end
			elseif (JukedDB.growUp==-1) then
				if (JukedDB.cols>6) then
					bar[ability]:SetPoint("TOPRIGHT",bar,"TOP",x-((JukedDB.cols-6)*30)+30,y)
				elseif (JukedDB.cols==6) then 
					bar[ability]:SetPoint("TOPRIGHT",bar,"TOP",x,y)
				else
					bar[ability]:SetPoint("TOPRIGHT",bar,"TOP",x+30,y)
				end
			elseif (JukedDB.growLeft==-1) then
				if (JukedDB.cols == 0)then
					bar[ability]:SetPoint("CENTER",bar,"CENTER",x+((getTotalMain()/2)*30)+60,y)
				elseif (JukedDB.cols>8) then
					if (JukedDB.cols%2==0) then
						bar[ability]:SetPoint("TOPRIGHT",bar,"TOP",x+((JukedDB.cols-2)*30)-30,y)
					else
						bar[ability]:SetPoint("TOPRIGHT",bar,"TOP",x+((JukedDB.cols-2)*30)-15-((JukedDB.cols-10)*30),y)
					end
				elseif (JukedDB.cols>4) then
					bar[ability]:SetPoint("TOPRIGHT",bar,"TOP",x+((JukedDB.cols-1)*30),y)
				else
					bar[ability]:SetPoint("TOPRIGHT",bar,"TOP",x+((JukedDB.cols)*30)+(30*(JukedDB.cols%2))-15*(JukedDB.cols%2),y)
				end
			end
			bar[ability]:Show()
			x = x + 30 * JukedDB.growLeft
			count = count + 1
			if count >= JukedDB.cols and JukedDB.cols > 0 then
				y = y - 30 * JukedDB.growUp
				x=-60
				count=0
			end
		end
	end
		local main=getTotalMain()
	if JukedDB.cols == 0 then
		bar:SetWidth(30*main)
	else
		bar:SetWidth(30*JukedDB.cols)
	end
	local numprio=getTotalPrio()
	if JukedDB.prio then
		if JukedDB.colsPrio == 0 then
			bar2:SetWidth(30*numprio)
		else
			bar2:SetWidth(30*JukedDB.colsPrio)
		end
	end
end


local function Juked_SavePosition()
	local point, _, relativePoint, xOfs, yOfs = bar:GetPoint()
	if not JukedDB.Position then 
		JukedDB.Position = {}
	end
	--first bar
	JukedDB.Position.point = point
	JukedDB.Position.relativePoint = relativePoint
	JukedDB.Position.xOfs = xOfs
	JukedDB.Position.yOfs = yOfs
	--second bar
	local point, _, relativePoint, xOfs, yOfs = bar2:GetPoint()
	JukedDB.Position.point2 = point
	JukedDB.Position.relativePoint2 = relativePoint
	JukedDB.Position.xOfs2 = xOfs
	JukedDB.Position.yOfs2 = yOfs
end

local function Juked_LoadPosition()
	if JukedDB.Position then
		bar:SetPoint(JukedDB.Position.point,UIParent,JukedDB.Position.relativePoint,JukedDB.Position.xOfs,JukedDB.Position.yOfs)
		if JukedDB.Position.point2 then
			bar2:SetPoint(JukedDB.Position.point2,UIParent,JukedDB.Position.relativePoint2,JukedDB.Position.xOfs2,JukedDB.Position.yOfs2)
		else
			bar2:SetPoint("CENTER", UIParent, "CENTER")
		end
	else
		bar:SetPoint("CENTER", UIParent, "CENTER")
		bar2:SetPoint("CENTER", UIParent, "CENTER")
	end
end

local function Juked_Repos()
	if (JukedDB.bgOnly and not bg and JukedDB.arenaOnly and not arena) or (not JukedDB.bgOnly and JukedDB.arenaOnly and not arena) or (not JukedDB.arenaOnly and JukedDB.bgOnly and not bg) then return end
	x = -60
	count=0
	y=0
	x2 = -60
	count2 = 0
	y2 = 0
	if not JukedDB.smart then
		for _,v in ipairs(spell_table) do
			if not (JukedDB.prio and isPrio(v.spellID)) then
				bar[v.spellID]:Hide()
				Juked_AddIcon(v.spellID)
				if JukedDB.hidden and not activetimers[v.spellID] then
					bar[v.spellID]:Hide()
				end
			end
		end
	else 
		for _,v in ipairs(spell_table) do
			if not(isPrio(v.spellID) and JukedDB.prio) then
				bar[v.spellID]:Hide()
				if activetimers[v.spellID] then
					Juked_AddIcon(v.spellID)
				else 
					if JukedDB.hidden then
						bar[v.spellID]:Hide()
					end
				end
			end
		end
	end
	if JukedDB.prio then
		if not JukedDB.smartPrio then
			for _,v in ipairs(spell_table) do
				if JukedDB.prio and isPrio(v.spellID) then
					bar2[v.spellID]:Hide()
					Juked_AddIcon(v.spellID)
					if JukedDB.hidden2 and not activetimers[v.spellID] then
						bar2[v.spellID]:Hide()
					end
				end
			end
		else
			for _,v in ipairs(spell_table) do
				if JukedDB.prio and isPrio(v.spellID) and JukedDB.hidden2 then
					bar2[v.spellID]:Hide()
					if activetimers[v.spellID] then
						Juked_AddIcon(v.spellID)
					else
						if JukedDB.hidden2 then
							bar2[v.spellID]:Hide()
						end
					end
					
				end
				
			end
		end
	end
end

local function Juked_UpdateBar()
	bar:SetScale(JukedDB.scale)
	bar2:SetScale(JukedDB.scale2)
	
	local main=getTotalMain()
	local numprio=getTotalPrio()
	if JukedDB.cols == 0 then
		bar:SetWidth(30*main)
	else
		bar:SetWidth(30*JukedDB.cols)
	end
	if JukedDB.prio then
		if JukedDB.colsPrio == 0 then
			bar2:SetWidth(30*numprio)
		else
			bar2:SetWidth(30*JukedDB.colsPrio)
		end
	end
	if JukedDB.prio then
		bar2:Show()
	end
	if not JukedDB.prio then--if prio was disabled
		for _,v in ipairs(spell_table) do 
			if isPrio(v.spellID) and bar2[v.spellID] then--if spell is prio and on currently on bar2
				bar[v.spellID]=bar2[v.spellID] --move the spell back to bar1
			end
		end
		bar2:Hide()--hide bar2
	elseif JukedDB.prio and table.getn(bar2) == 0 then--if prio is on and bar2 is empty
		for _,v in ipairs(spell_table) do
			if JukedDB.prio and isPrio(v.spellID) then--if spell is prio and prio is on
				if bar[v.spellID] and not bar2[v.spellID] then
					bar2[v.spellID]=bar[v.spellID]--put spell on bar2
				end
			end
		end
	end
	--if bgonly mode is on, and not in a bg, or arenaonly and not in arena, or bgonly and arenaonly modes and not in bg or arena
	if (JukedDB.bgOnly and not bg and JukedDB.arenaOnly and not arena) or (not JukedDB.bgOnly and JukedDB.arenaOnly and not arena) or (not JukedDB.arenaOnly and JukedDB.bgOnly and not bg) then 
		for _,v in ipairs(spell_table) do
			if JukedDB.prio and isPrio(v.spellID) then
				bar2[v.spellID]:Hide()--hide spells on prio and main bar
			else
				bar[v.spellID]:Hide()
			end
		end
		return
	end
	if JukedDB.hidden or JukedDB.hidden2 or JukedDB.smart or JukedDB.smartPrio then
		if JukedDB.smart or JukedDB.smartPrio then
			x = -60--if smart, reset the icon positioning variables
			count=0
			y=0
		--end
		--if JukedDB.smartPrio then
			x2 = -60
			y2 = 0
			count2 = 0
		end
		for _,v in ipairs(spell_table) do
			if JukedDB.prio and isPrio(v.spellID) then
				if JukedDB.hidden2 or JukedDB.smartPrio then
					bar2[v.spellID]:Hide()--hide spells on bar2
				else
					bar2[v.spellID]:Show()
				end
				bar2[v.spellID].cd.noomnicc = not JukedDB.noCD
				bar2[v.spellID].cd.noOCC = not JukedDB.noCD--set correct flags to enable/disable omniCC 
				bar2[v.spellID].cd.noCooldownCount = not JukedDB.noCD
				bar2[v.spellID]:SetParent(bar2)
			else	
				if JukedDB.hidden or JukedDB.smart then
					bar[v.spellID]:Hide()--hide spells on main bar
				else
					bar[v.spellID]:Show()
				end
				bar[v.spellID].cd.noomnicc = not JukedDB.noCD
				bar[v.spellID].cd.noOCC = not JukedDB.noCD--set correct flags to enable/disable omniCC 
				bar[v.spellID].cd.noCooldownCount = not JukedDB.noCD
				bar[v.spellID]:SetParent(bar)
			end
		end
	else--if not hidden or smart
		for _,v in ipairs(spell_table) do
			if JukedDB.prio and isPrio(v.spellID) then
				bar2[v.spellID]:Show() --show spell
				bar2[v.spellID].cd.noomnicc = not JukedDB.noCD
				bar2[v.spellID].cd.noOCC = not JukedDB.noCD--set correct flags to enable/disable omniCC 
				bar2[v.spellID].cd.noCooldownCount = not JukedDB.noCD
				bar2[v.spellID]:SetParent(bar2)
			else
				bar[v.spellID]:Show() 
				bar[v.spellID].cd.noomnicc = not JukedDB.noCD
				bar[v.spellID].cd.noOCC = not JukedDB.noCD
				bar[v.spellID].cd.noCooldownCount = not JukedDB.noCD
				bar[v.spellID]:SetParent(bar)
			end
		end
	end
	if JukedDB.prioOnly then--if prio only
		for _,v in ipairs(spell_table) do
			if not isPrio(v.spellID) then--hide non-prio spells
				bar[v.spellID]:Hide()
			end
		end
	end
	if JukedDB.lock then--if bar is locked, disable mouse
		bar:EnableMouse(false)
	else--else, enable mouse
		bar:EnableMouse(true)
	end
	if JukedDB.lockPrio then
		bar2:EnableMouse(false)
	else
		bar2:EnableMouse(true)
	end
end

local function Juked_CreateBar()
	bar = CreateFrame("Frame", nil, UIParent)
	bar:SetMovable(true)
	bar:SetWidth(120)
	bar:SetHeight(30)
	bar:SetClampedToScreen(true) 
	bar:SetScript("OnMouseDown",function(self,button) if button == "LeftButton" then self:StartMoving() end end)
	bar:SetScript("OnMouseUp",function(self,button) if button == "LeftButton" then self:StopMovingOrSizing() Juked_SavePosition() end end)
	bar:Show()

	bar2 = CreateFrame("Frame", nil, UIParent)
	bar2:SetMovable(true)
	bar2:SetWidth(120)
	bar2:SetHeight(30)
	bar2:SetClampedToScreen(true) 
	bar2:SetScript("OnMouseDown",function(self,button) if button == "LeftButton" then self:StartMoving() end end)
	bar2:SetScript("OnMouseUp",function(self,button) if button == "LeftButton" then self:StopMovingOrSizing() Juked_SavePosition() end end)
	bar2:Show()
	
	Juked_AddIcons()
	Juked_UpdateBar()
	Juked_LoadPosition()
end

local function Juked_UpdateText(text,cooldown)
if  JukedDB.noCD then return end
	if cooldown < 100 then 
		if cooldown <= 0.5 then
			text:SetText("")
		elseif cooldown < 10 then
			text:SetFormattedText(" %d",cooldown)
		else
			text:SetFormattedText("%d",cooldown)
		end
	else
		local m=floor((cooldown+30)/60)
		text:SetFormattedText("%dm",m)
	end
	if cooldown < 6 then 
		text:SetTextColor(1,0,0,1)
	else 
		text:SetTextColor(1,1,0,1) 
	end
end

local function Juked_StopAbility(ref,ability)
	if (JukedDB.hidden2 and isPrio(ability)) or (JukedDB.hidden and not isPrio(ability)) then
		ref:Hide()
	end
	if activetimers[ability] then activetimers[ability] = nil end
	ref.text:SetText("")
	ref.cd:Hide()
	if (JukedDB.hidden or JukedDB.hidden2) and (JukedDB.smart or JukedDB.smartPrio) then Juked_Repos() end
end

local time = 0
local function Juked_OnUpdate(self, elapsed)
	time = time + elapsed
	if time > 0.25 then
		getsize()
		for ability,ref in pairs(activetimers) do
			ref.cooldown = ref.start + ref.duration - GetTime()
			if ref.cooldown <= 0 then
				Juked_StopAbility(ref,ability)
			else 
				Juked_UpdateText(ref.text,floor(ref.cooldown+0.5))
			end
		end
		if size == 0 then frame:SetScript("OnUpdate",nil) end
		time = time - 0.25
	end
end

local function Juked_StartTimer(ref,ability)
	if (JukedDB.bgOnly and not bg and JukedDB.arenaOnly and not arena) or (not JukedDB.bgOnly and JukedDB.arenaOnly and not arena) or (not JukedDB.arenaOnly and JukedDB.bgOnly and not bg) then return end
	if JukedDB.hidden or JukedDB.hidden2 or JukedDB.smart or JukedDB.smartPrio then
		ref:Show()
	end
	--if not activetimers[ability] then
		local duration
		activetimers[ability] = ref
		ref.cd:Show()
		ref.cd:SetCooldown(GetTime()-0.40,ref.duration)
		ref.start = GetTime()
		Juked_UpdateText(ref.text,ref.duration)
	--end
	frame:SetScript("OnUpdate",Juked_OnUpdate)
end

local function Juked_COMBAT_LOG_EVENT_UNFILTERED(...)
	local spellID, ability, useSecondDuration
	return function(_, eventtype, _, srcName, srcFlags, _, dstName, dstFlags, id)
		if (band(srcFlags, 0x00000040) == 0x00000040 and (eventtype == "SPELL_CAST_SUCCESS" or eventtype == "SPELL_AURA_APPLIED")) then 
			spellID = id
		else
			return
		end
		if spellID == 49376 then spellID = 16979; useSecondDuration = true end -- Feral Charge - Cat -> Feral Charge - Bear
		if spellID == 91797 then spellID = 91800; end
		if (JukedDB.prioOnly and not isPrio(spellID)) then return end
		if (JukedDB.bgOnly and not bg and JukedDB.arenaOnly and not arena) or (not JukedDB.bgOnly and JukedDB.arenaOnly and not arena) or (not JukedDB.arenaOnly and JukedDB.bgOnly and not bg) then return end
		local cold_snap={82676,44572,45438}
		local prep={1766,1856,36554,51722}
		local readiness={19263,19503}
		
		if spellID == 11958 then --cold snap 82676 Ring of Frost -- 44572 Deep Freeze -- 45438 Ice Block
			if JukedDB.prio and isPrio(ability) then
				for _,abil in ipairs(cold_snap) do
					if activetimers[abil] then
						Juked_StopAbility(bar2[abil],abil)
					end
				end
			else
				for _,abil in ipairs(cold_snap) do
					if activetimers[abil] then
						Juked_StopAbility(bar[abil],abil)
					end
				end
			end
		elseif spellID == 14185 then --prep
			if JukedDB.prio and isPrio(ability) then
				for _,abil in ipairs(prep) do
					if activetimers[abil] then
						Juked_StopAbility(bar2[abil],abil)
					end
				end
			else
				for _,abil in ipairs(prep) do
					if activetimers[abil] then
						Juked_StopAbility(bar[abil],abil)
					end
				end
			end
			--[[ 1766  Kick 1856  Vanish 36554 Shadowstep 76577 Smoke Bomb 51722 Dismantle
				Non tracked: Sprint, Smoke Bomb]]
		elseif spellID == 23989 then --readiness
			if JukedDB.prio and isPrio(ability) then
				for _,abil in ipairs(readiness) do
					if activetimers[abil] then
						Juked_StopAbility(bar2[abil],abil)
					end
				end
			else
				for _,abil in ipairs(readiness) do
					if activetimers[abil] then
						Juked_StopAbility(bar[abil],abil)
					end
				end
			end
		end
		useSecondDuration = false

		if abilities[spellID] then	
			if useSecondDuration and spellID == 16979 then
				if JukedDB.prio and isPrio(spellID) then
					bar2[spellID].duration=30
				else
					bar[spellID].duration=30
				end
			elseif spellID == 16979 then
				if JukedDB.prio and isPrio(spellID) then
					bar2[spellID].duration=15
				else
					bar[spellID].duration=15
				end
			end
			--if JukedDB.smart or JukedDB.smartPrio then
			--	Juked_AddIcon(spellID)
			--end
			if JukedDB.prio and isPrio(spellID) then
				if JukedDB.smartPrio then Juked_AddIcon(spellID) end
				Juked_StartTimer(bar2[spellID],spellID)
			else
				if JukedDB.smart then Juked_AddIcon(spellID) end
				Juked_StartTimer(bar[spellID],spellID)
			end
		end
	end
end

Juked_COMBAT_LOG_EVENT_UNFILTERED = Juked_COMBAT_LOG_EVENT_UNFILTERED()


local function Juked_ResetAllTimers()
	for _,ability in ipairs(spell_table) do
		if JukedDB.prio and isPrio(ability.spellID) then
			Juked_StopAbility(bar2[ability.spellID],ability.spellID)
		else
			Juked_StopAbility(bar[ability.spellID],ability.spellID)
		end
	end
	if not (JukedDB.smart or JukedDB.smartPrio) and not ((JukedDB.smart or JukedDB.smartPrio) and (JukedDB.hidden or JukedDB.hidden2)) then
		Juked_Repos()
	end

end

local function Juked_Reset()
	JukedDB = JukedDB or { scale = 1,scale2=1, hidden = false,hidden2=false, smart=false,smartPrio=false,prio = false, cols=6, colsPrio=6, arenaOnly=false, bgOnly=false, lock = false,lockPrio=false,growUp=1,growLeft=-1 ,noCD=false,prioOnly=false,lockPrio=false}
	Juked_ResetAllTimers()
	Juked_UpdateBar()
	Juked_LoadPosition()
end
local function Juked_PLAYER_ENTERING_WORLD(self)
	arena=isInArena()
	bg=isInBG()
	Juked_Reset()
end
local function Juked_Test()
	if (JukedDB.smart or JukedDB.smartPrio) and (JukedDB.hidden or JukedDB.hidden2) then 
		Juked_Repos()
	end
	if JukedDB.prioOnly then 
		for _,ability in ipairs(spell_table) do
			if isPrio(ability.spellID) then
				if JukedDB.smartPrio then Juked_AddIcon(ability.spellID) end
				if JukedDB.prio then
					Juked_StartTimer(bar2[ability.spellID],ability.spellID)
				else
					Juked_StartTimer(bar[ability.spellID],ability.spellID)
				end
			end
		end
	else
		for _,ability in ipairs(spell_table) do
			if JukedDB.prio and isPrio(ability.spellID) then
				if JukedDB.smartPrio then Juked_AddIcon(ability.spellID) end
				Juked_StartTimer(bar2[ability.spellID],ability.spellID)
			else
			if JukedDB.smart then Juked_AddIcon(ability.spellID) end
				Juked_StartTimer(bar[ability.spellID],ability.spellID)
			end
		end
	end
end


local cmdfuncs = {
	config = function() 
		ChatFrame1:AddMessage("Scale - Main Bar(1) = "..JukedDB.scale.."  Prio Bar(2) = "..JukedDB.scale2,0,1,1)
		local cd="Disabled"
		if (JukedDB.hidden) then cd="Enabled"; end
		ChatFrame1:AddMessage("Hidden(1) - "..cd,0,1,1)
		cd="Disabled"
		if (JukedDB.hidden2) then cd="Enabled"; end
		ChatFrame1:AddMessage("Hidden(2) - "..cd,0,1,1)
		cd="Disabled"
		if (JukedDB.smart) then cd="Enabled"; end
		ChatFrame1:AddMessage("Smart(1) - "..cd,0,1,1)
		cd="Disabled"
		if (JukedDB.smartPrio) then cd="Enabled"; end
		ChatFrame1:AddMessage("Smart(2) - "..cd,0,1,1)
		cd="unlocked"
		if (JukedDB.lock) then cd="locked"; end
		ChatFrame1:AddMessage("Locked(1) - "..cd,0,1,1)
		cd="unlocked"
		if (JukedDB.lockPrio) then cd="locked"; end
		ChatFrame1:AddMessage("Locked(2) - "..cd,0,1,1)
		cd="Disabled"
		if (JukedDB.prio) then cd="Enabled"; end
		ChatFrame1:AddMessage("Prio - "..cd,0,1,1)
		cd="Disabled"
		if (JukedDB.arenaOnly) then cd="Enabled"; end
		ChatFrame1:AddMessage("ArenaOnly - "..cd,0,1,1)
		cd="Disabled"
		if (JukedDB.bgOnly) then cd="Enabled"; end
		ChatFrame1:AddMessage("BGOnly - "..cd,0,1,1)
		cd="growing down"
		if (JukedDB.growUp==-1) then cd="growing up"; end
		ChatFrame1:AddMessage("Cooldowns are "..cd.." from the anchor",0,1,1)
		cd="Disabled"
		cd="growing right"
		if (JukedDB.growLeft==-1) then cd="growing left"; end
		ChatFrame1:AddMessage("Cooldowns are "..cd.." from the anchor",0,1,1)
		cd="Disabled"
		if (not JukedDB.noCD) then cd="Enabled"; end
		ChatFrame1:AddMessage("Juked cooldown display is "..cd,0,1,1)
		cd="all spell cooldowns"
		if (JukedDB.prioOnly) then cd="ONLY priority cooldowns"; end
		ChatFrame1:AddMessage("Displaying "..cd.."(PrioOnly mode="..tostring(JukedDB.prioOnly)..")",0,1,1)
		ChatFrame1:AddMessage("Columns per row:  Main Bar(1) = "..JukedDB.cols.."  Prio Bar(2) = "..JukedDB.colsPrio,0,1,1)
	end,
	scale = function(id,v) 
		if not id or not v then 
			ChatFrame1:AddMessage("USAGE: scale <bar ID> <number>",0,1,0)
			ChatFrame1:AddMessage("Bar IDs: Main bar = 1   Prio Bar = 2",0,1,0)
			ChatFrame1:AddMessage("Current settings: Main Bar(1) = "..JukedDB.scale.."  Prio Bar(2) = "..JukedDB.scale2,0,1,0)
			return
		end
		if ((id == 1 or id == 2) and v >= 0) then 
			if id==1 then
				JukedDB.scale = v
			elseif id == 2 then
				JukedDB.scale2=v
			end
			ChatFrame1:AddMessage("Scale for bar"..id.." set to"..v,0,1,0)
			Juked_UpdateBar()
			return
		end
		ChatFrame1:AddMessage("USAGE: scale <bar ID> <number>",0,1,0)
		ChatFrame1:AddMessage("Bar IDs: Main bar = 1   Prio Bar = 2",0,1,0)
		ChatFrame1:AddMessage("Current settings: Main Bar(1) = "..JukedDB.scale.."  Prio Bar(2) = "..JukedDB.scale2,0,1,0)
	end,
	hidden = function(id) 
		if not id then 
			ChatFrame1:AddMessage("USAGE: hidden <bar ID>",0,1,0)
			ChatFrame1:AddMessage("Bar IDs: Main bar = 1   Prio Bar = 2",0,1,0)
			return
		end
		if ((id == 1 or id == 2)) then 
			local cd="Disabled"
			if id == 1 then
				JukedDB.hidden = not JukedDB.hidden
				if (JukedDB.hidden) then cd="Enabled"; end
			elseif id == 2 then
				JukedDB.hidden2 = not JukedDB.hidden2
				if (JukedDB.hidden2) then cd="Enabled"; end
			end
			ChatFrame1:AddMessage("Juked hidden("..id..") mode is now "..cd,0,1,1)
			ChatFrame1:AddMessage("Enabled = Spells are hidden when not on cooldown",0,1,0)
			ChatFrame1:AddMessage("Disabled = Spells are always visible",0,1,0)
			ChatFrame1:AddMessage("Note: If Smart & Hidden mode are enabled, the cooldowns realign to the anchor when off cooldown",0,1,0)
			Juked_UpdateBar() 
			Juked_Repos() 
		end
	end,
	smart = function(id) 
		if not id then 
			ChatFrame1:AddMessage("USAGE: smart <bar ID>",0,1,0)
			ChatFrame1:AddMessage("Bar IDs: Main bar = 1   Prio Bar = 2",0,1,0)
			return
		end
		local cd="Disabled"
		if ((id == 1 or id == 2)) then 
			if id == 1 then
				JukedDB.smart = not JukedDB.smart
				if (JukedDB.smart) then cd="Enabled"; end
			elseif id == 2 then
				JukedDB.smartPrio = not JukedDB.smartPrio
				if (JukedDB.smartPrio) then cd="Enabled"; end
			end
		end
		ChatFrame1:AddMessage("Juked smart mode is now "..cd,0,1,1)
		ChatFrame1:AddMessage("Enabled = Spells are only displayed once used and in the order they're used",0,1,0)
		ChatFrame1:AddMessage("Disabled = Spells are always displayed in the same order",0,1,0)
		ChatFrame1:AddMessage("Note: If Smart & Hidden mode are enabled, the cooldowns realign to the anchor when off cooldown",0,1,0)
		Juked_Reset() 
	end,
	lock = function(id) 
		if not id then 
			ChatFrame1:AddMessage("USAGE: lock <bar ID>",0,1,0)
			ChatFrame1:AddMessage("Bar IDs: Main bar = 1   Prio Bar = 2",0,1,0)
			return
		end
		if ((id == 1 or id == 2)) then 
			local cd="unlocked"
			if id == 1 then
				JukedDB.lock = not JukedDB.lock
				if (JukedDB.hidden) then cd="locked"; end
			elseif id == 2 then
				JukedDB.lockPrio = not JukedDB.lockPrio
				if (JukedDB.lockPrio) then cd="locked"; end
			end
			ChatFrame1:AddMessage("Juked bar"..id.." is now "..cd,0,1,1)
		end
		ChatFrame1:AddMessage("Locked = Bars can't be moved",0,1,0)
		ChatFrame1:AddMessage("Unlocked = Bars can be moved",0,1,0)
		Juked_UpdateBar()
	end,
	prio = function() 
		JukedDB.prio = not JukedDB.prio
		local cd="Disabled"
		if (JukedDB.prio) then cd="Enabled"; end
		ChatFrame1:AddMessage("Juked Prio bar is now "..cd,0,1,1)
		ChatFrame1:AddMessage("Enabled = A second bar is created, displaying priority spells",0,1,0)
		ChatFrame1:AddMessage("Disabled = Juked displays all spells on the main bar",0,1,0)
		local temp1=JukedDB.smart
		local temp2=JukedDB.smartPrio

		Juked_UpdateBar()
		JukedDB.smartPrio=false
		JukedDB.smart=false
		Juked_Repos() 
		JukedDB.smart=temp1
		JukedDB.smartPrio=temp2
		Juked_UpdateBar()
	end,
	arenaonly = function() 
		JukedDB.arenaOnly = not JukedDB.arenaOnly
		local cd="Disabled"
		if (JukedDB.arenaOnly) then cd="Enabled"; end
		ChatFrame1:AddMessage("Juked Arena Only mode is now "..cd,0,1,1)
		ChatFrame1:AddMessage("Enabled = Juked is displayed ONLY in Arenas",0,1,0)
		ChatFrame1:AddMessage("Disabled = Juked is displayed outside of Arenas",0,1,0)
		ChatFrame1:AddMessage("Note: If BGOnly & ArenaOnly are enabled, it will work in Arenas and BGs",0,1,0)
		Juked_Reset() 
	end,
	bgonly = function() 
		JukedDB.bgOnly = not JukedDB.bgOnly
		local cd="Disabled"
		if (JukedDB.bgOnly) then cd="Enabled"; end
		ChatFrame1:AddMessage("Juked BG Only mode is now "..cd,0,1,1)
		ChatFrame1:AddMessage("Enabled = Juked is displayed ONLY in Battlegrounds",0,1,0)
		ChatFrame1:AddMessage("Disabled = Juked is displayed outside of Battlegrounds",0,1,0)
		ChatFrame1:AddMessage("Note: If BGOnly & ArenaOnly are enabled, it will work in Arenas and BGs",0,1,0)
		Juked_Reset() 
	end,
	growup=function() 		
		JukedDB.growUp=JukedDB.growUp*-1
		local text="growing down"
		if (JukedDB.growUp==-1) then text="growing up"; end
		ChatFrame1:AddMessage("Juked cooldowns are "..text.." from the anchor",0,1,1)
		Juked_Repos()
		end,
	growleft=function() 		
		JukedDB.growLeft=JukedDB.growLeft*-1
		local text="growing right"
		if (JukedDB.growLeft==-1) then text="growing left"; end
		ChatFrame1:AddMessage("Juked cooldows are "..text.." from the anchor",0,1,1)
		Juked_Repos()
		end,
	nocd=function() 
		JukedDB.noCD = not JukedDB.noCD
		local cd="Disabled"
		if (not JukedDB.noCD) then cd="Enabled"; end
		ChatFrame1:AddMessage("Juked cooldown display is now "..cd,0,1,1)
		ChatFrame1:AddMessage("Enabled = Juked displays text",0,1,0)
		ChatFrame1:AddMessage("Disabled = Juked displays no text, OmniCC can be used",0,1,0)
		Juked_Reset()
	end,
	prioonly=function()
		JukedDB.prioOnly=not JukedDB.prioOnly
		local cd="all spell cooldowns"
		if (JukedDB.prioOnly) then cd="ONLY priority cooldowns"; end
		ChatFrame1:AddMessage("Juked is now displaying "..cd,0,1,1)
		Juked_Reset()  
	end,
	cols = function(id,v) 
		if not id or not v then 
			ChatFrame1:AddMessage("USAGE: cols <bar ID> <number>",0,1,0)
			ChatFrame1:AddMessage("Bar IDs: Main bar = 1   Prio Bar = 2",0,1,0)
			ChatFrame1:AddMessage("Current settings: Main Bar(1) = "..JukedDB.cols.."  Prio Bar(2) = "..JukedDB.colsPrio,0,1,0)
			return
		end
		if ((id == 1 or id == 2) and v >= 0) then 
			if id==1 then
				JukedDB.cols = v
			elseif id==2 then
				JukedDB.colsPrio = v
			end
			ChatFrame1:AddMessage("Cols for bar"..id.." set to"..v,0,1,0)
			Juked_Repos()
			return	
		end
		ChatFrame1:AddMessage("USAGE: /juked cols <bar ID> <number>",0,1,0)
		ChatFrame1:AddMessage("Bar IDs: Main bar = 1   Prio Bar = 2",0,1,0)
		ChatFrame1:AddMessage("Current settings: Main Bar(1) = "..JukedDB.cols.."  Prio Bar(2) = "..JukedDB.colsPrio,0,1,0)
		ChatFrame1:AddMessage("Example: set main bar cols to 6: /juked cols 1 6",0,1,0)
	end,
	reset = function() Juked_Reset() end,
	test = function() Juked_Test() end,
}

local cmdtbl = {}
function Juked_Command(cmd)
	for k in ipairs(cmdtbl) do
		cmdtbl[k] = nil
	end
	for v in gmatch(cmd, "[%d|%a|.]+") do
		tinsert(cmdtbl, v)
	end
  local cb = cmdfuncs[cmdtbl[1]] 
  if cb then
  	local s = tonumber(cmdtbl[2])
  	local ss = tonumber(cmdtbl[3])
  	cb(s,ss)
  else
	ChatFrame1:AddMessage("Juked Help",0,1,0)
	ChatFrame1:AddMessage("config - Display current value of options",0,1,0)
	ChatFrame1:AddMessage("scale <bar ID> <number> - Sets the scale factor for the given bar",0,1,0)
  	ChatFrame1:AddMessage("hidden <bar ID> (toggle) - Hides spell icons when off cooldown",0,1,0)
	ChatFrame1:AddMessage("smart <bar ID>(toggle) - Only show CD when used",0,1,0)
  	ChatFrame1:AddMessage("lock <bar ID>(toggle) - Locks the bars in place",0,1,0)
	ChatFrame1:AddMessage("growup (toggle) - The icons grow upwards from the anchor if enabled",0,1,0)
	ChatFrame1:AddMessage("growleft (toggle) - The icons grow left from the anchor if enabled",0,1,0)
	ChatFrame1:AddMessage("prio (toggle) - Displays second anchor with priority spells",0,1,0)
	ChatFrame1:AddMessage("arenaonly (toggle) - Only display cooldowns if in an arena",0,1,0)
	ChatFrame1:AddMessage("bgonly (toggle) - Only display cooldowns if in a battleground",0,1,0)
	ChatFrame1:AddMessage("prioonly (toggle) - Only displays priority cooldowns",0,1,0)
	ChatFrame1:AddMessage("nocd (toggle) - Disables the Juked cooldown text and allows omniCC",0,1,0)
	ChatFrame1:AddMessage("cols <bar ID> <num> (0 = 1 row) - Set number of spells per row for the given bar",0,1,0)
  	ChatFrame1:AddMessage("test - Activates all cooldowns to test Juked",0,1,0)
  	ChatFrame1:AddMessage("reset - Resets all cooldowns",0,1,0)
	
	--[[ChatFrame1:AddMessage("scale <bar ID> <number> | " .. "bar1="..JukedDB.scale.."bar2="..JukedDB.scale2,0,1,0)
  	ChatFrame1:AddMessage("hidden (toggle) Hide when off CD | " .. tostring(JukedDB.hidden),0,1,0)
	ChatFrame1:AddMessage("smart (toggle) Only show CD when used | " .. tostring(JukedDB.smart),0,1,0)
  	ChatFrame1:AddMessage("lock (toggle) | " .. tostring(JukedDB.lock),0,1,0)
	local grow=false;
	if (JukedDB.growUp==-1) then grow=true; end
	ChatFrame1:AddMessage("growup (toggle) | " .. tostring(JukedDB.growUp==-1),0,1,0)
	ChatFrame1:AddMessage("prio (toggle second anchor w/ priority spells) | " .. tostring(JukedDB.prio),0,1,0)
	ChatFrame1:AddMessage("arenaonly (toggle arena only mode) | " .. tostring(JukedDB.arenaOnly),0,1,0)
	ChatFrame1:AddMessage("bgonly (toggle bg only mode) | " .. tostring(JukedDB.bgOnly),0,1,0)
	ChatFrame1:AddMessage("prioonly (toggle prio only mode) | " .. tostring(JukedDB.prioOnly),0,1,0)
	ChatFrame1:AddMessage("nocd (toggle cd display) | " .. tostring(JukedDB.noCD),0,1,0)
	ChatFrame1:AddMessage("cols <bar ID> <num> (0 = 1 row) | bar1=" .. tostring(JukedDB.cols).." bar2=" .. tostring(JukedDB.colsPrio),0,1,0)
  	ChatFrame1:AddMessage("test (execute)",0,1,0)
  	ChatFrame1:AddMessage("reset (execute)",0,1,0)]]
  end
end

local function Juked_OnLoad(self)
	self:RegisterEvent("PLAYER_ENTERING_WORLD")
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	if not JukedDB.scale then JukedDB.scale = 1 end
	if not JukedDB.scale2 then JukedDB.scale2 = 1 end
	if not JukedDB.hidden then JukedDB.hidden = false end
	if not JukedDB.hidden2 then JukedDB.hidden2 = false end
	if not JukedDB.smart then JukedDB.smart = false end
	if not JukedDB.smartPrio then JukedDB.smartPrio = false end
	if not JukedDB.prio then JukedDB.prio = false end
	if not JukedDB.growUp then JukedDB.growUp=1 end
	if not JukedDB.growLeft then JukedDB.growLeft=1 end
	if not JukedDB.arenaOnly then JukedDB.arenaOnly=false end
	if not JukedDB.bgOnly then JukedDB.bgOnly=false end
	if not JukedDB.noCD then JukedDB.noCD=false end
	if not JukedDB.cols then JukedDB.cols = 6 end
	if not JukedDB.colsPrio then JukedDB.colsPrio = 6 end
	if not JukedDB.prioOnly then JukedDB.prioOnly=false end
	if not JukedDB.lock then JukedDB.lock = false end
	if not JukedDB.lockPrio then JukedDB.lockPrio = false end
	Juked_CreateBar()
	
	SlashCmdList["Juked"] = Juked_Command
	SLASH_Juked1 = "/juked"
	SLASH_Juked2 = "/jd"
	SLASH_Juked3 = "/ib"
	ChatFrame1:AddMessage("Juked by Robrman, inspired by Kollektiv's InterruptBar. Type /juked or /jd for options.",0,1,0)
end

local eventhandler = {
	["VARIABLES_LOADED"] = function(self) Juked_OnLoad(self) end,
	["PLAYER_ENTERING_WORLD"] = function(self) Juked_PLAYER_ENTERING_WORLD(self) end,
	["COMBAT_LOG_EVENT_UNFILTERED"] = function(self,...) Juked_COMBAT_LOG_EVENT_UNFILTERED(...) end,
}

local function Juked_OnEvent(self,event,...)
	eventhandler[event](self,...)
end

frame = CreateFrame("Frame",nil,UIParent)
frame:SetScript("OnEvent",Juked_OnEvent)
frame:RegisterEvent("VARIABLES_LOADED")
